#include "GmailNotifier.h"


GmailNotifier::GmailNotifier() {

}

GmailNotifier::GmailNotifier(const char* username, const char* password) {
    this->_username = username;
    this->_password = password;
}

void GmailNotifier::setUsername(const char* username) {
    this->_username = username;
    this->_base64Encoded = false;
}

void GmailNotifier::setPassword(const char* password) {
    this->_password = password;
    this->_base64Encoded = false;
}

bool GmailNotifier::sync() {
    bool isSyncSuccessful = false;
    if (!this->_base64Encoded)
        base64Encode();
    this->_client.begin(this->_url, F("0B 00 8F 43 07 1A 24 8E F5 66 A6 A2 08 5A C1 10 26 86 5F AF"));
    this->_client.addHeader(F("Host"), F("mail.google.com"));
    this->_client.addHeader(F("Authorization"), String(F("Basic ")) + String(this->_encodedLoginCredentials));
    if (this->_client.GET() == HTTP_CODE_OK) {
        String response = this->_client.getString();
        int16_t fullcountPos = response.indexOf(F("<fullcount>"));
        int16_t fullcountClosePos = response.indexOf(F("</fullcount>"), fullcountPos);
        if (fullcountPos > 0 && fullcountClosePos > 0) {
            isSyncSuccessful = true;
            this->_unread = response.substring(fullcountPos + 11, fullcountClosePos).toInt();
        } else {
            isSyncSuccessful = false;
            this->_unread = -2;
        }
    }
    this->_client.end();
    return isSyncSuccessful;
}

int16_t GmailNotifier::getUnread() {
    return this->_unread;
}

void GmailNotifier::base64Encode() {
    this->_encodedLoginCredentials = base64::encode(String(this->_username) + ":" + String(this->_password)).c_str();
    this->_base64Encoded = true;
}
