#include "YahooWeather.h"


YahooWeather::YahooWeather() {

}

YahooWeather::YahooWeather(const char* appId, const char* consumerKey, const char* consumerSecret, const char* url) {
    this->_appId            = appId;
    this->_consumerKey      = consumerKey;
    this->_consumerSecret   = consumerSecret;
    this->_url              = url;
}

void YahooWeather::setAppId(const char* appId) {
    this->_appId = appId;
}

void YahooWeather::setConsumerKey(const char* consumerKey) {
    this->_consumerKey = consumerKey;
}

void YahooWeather::setConsumerSecret(const char* consumerSecret) {
    this->_consumerSecret = consumerSecret;
}

void YahooWeather::setUrl(const char* url) {
    this->_url = url;
}

void YahooWeather::setUnit(uint8_t unit) {
    this->_unit = unit;
}

void YahooWeather::setFormat(uint8_t format) {
    this->_format = format;
}

void YahooWeather::setWoeid(const char* woeid) {
    this->_woeid = woeid;
}

void YahooWeather::setLocation(const char* location) {
    this->_location = location;
}

void YahooWeather::setCoordinates(const char* lat, const char* lon) {
    this->_lat = lat;
    this->_lon = lon;
}

void YahooWeather::request() {
    HTTPClient client;
    client.begin(this->_url + String(F("?")) + buildQuery());
    // client.setUserAgent();
    client.addHeader(F("X-Yahoo-App-Id"), this->_appId);
    client.addHeader(F("X-Yahoo-Consumer-Key"), this->_consumerKey);
    client.addHeader(F("X-Yahoo-Consumer-Secret"), this->_consumerSecret);
    client.addHeader(F("Cache-Control"), F("no-cache"));
    if (client.GET() == HTTP_CODE_OK) {
        this->response = client.getString();
    }
    client.end();
}

String YahooWeather::urlEncode(const char* str) {
    String encoded = "";
    const char* hex = "0123456789abcdef";
    for (uint8_t i = 0; i < strlen(str); i++) {
        if ( ('a' <= str[i] && str[i] <= 'z')
		|| ('A' <= str[i] && str[i] <= 'Z')
		|| ('0' <= str[i] && str[i] <= '9') ) {
            encoded += str[i];
        } else {
            encoded += hex[str[i] >> 4];
            encoded += hex[str[i] & 15];
        }
    }
    return encoded;
}

String YahooWeather::buildQuery() {
    String query = "";
    if (this->_woeid != "")
        query += String(F("woeid=")) + String(this->_woeid);
    else if (this->_location != "")
        query += String(F("location=")) + String(urlEncode(this->_location));
    else if (this->_lat != ""  && this->_lon != "")
        query += String(F("lat=")) + String(this->_lat) + F("&lon=") + String(this->_lon);
    query += F("&format=");
    query += this->_format == YahooWeather::FORMAT_JSON ? F("json") : F("xml");
    query += F("&u=");
    query += this->_unit == YahooWeather::UNIT_IMPERIAL ? F("f") : F("c");
    return query;
}
