#pragma once

#include "Arduino.h"
#include "ESP8266HTTPClient.h"


class YahooWeather {

    public:

        YahooWeather();
        YahooWeather(const char* appId, const char* consumerKey, const char* consumerSecret, const char* url);

        void setAppId(const char* appId);
        void setConsumerKey(const char* consumerSecret);
        void setConsumerSecret(const char* consumerSecret);
        void setUrl(const char* url);
        void setUnit(uint8_t unit);
        void setFormat(uint8_t format);
        void setWoeid(const char* woeid);
        void setLocation(const char* location);
        void setCoordinates(const char* lat, const char* lon);
        void request();

        static const uint8_t UNIT_IMPERIAL = 0X01;
        static const uint8_t UNIT_METRIC   = 0X02;
        static const uint8_t FORMAT_JSON   = 0X03;
        static const uint8_t FORMAT_XML    = 0X04;

        String response = "";

    private:

        String buildQuery();
        String urlEncode(const char* str);

        const char* _url            = "";
        const char* _appId          = "";
        const char* _consumerKey    = "";
        const char* _consumerSecret = "";

        uint8_t     _unit           = 0X01;
        uint8_t     _format         = 0X03;

        const char* _woeid          = "";
        const char* _location       = "";
        const char* _lat            = "";
        const char* _lon            = "";

};
